{ config, pkgs, ... }: let
  tex = (pkgs.texlive.combine {
      inherit (pkgs.texlive)
        scheme-full;
        # cyrillic
        # minted
        # tempora
        # dvisvgm dvipng # for preview and export as html
        # wrapfig amsmath ulem hyperref capt-of
        # relsize eulervm multirow;
        #(setq org-latex-compiler "lualatex")
        #(setq org-preview-latex-default-process 'dvisvgm)
    });
  eclipse-jdt-ls = pkgs.callPackage ./eclipse-jdt-ls.nix {};
in
{
  home.username = "apr";
  home.homeDirectory = "/home/apr";

  home.sessionVariables = { };
  home.stateVersion = "22.05";

  programs.home-manager.enable = true;

  programs.bash = {
    enable = true;
    bashrcExtra = ''
        export JAVA_HOME="/usr/lib/jvm/default-runtime/";
      . ~/.bashrc.backup
    '';
    profileExtra = ''
      . ~/.bash_profile.backup
    '';
  };

  # programs.texlive = pkgs.texlive.combined.scheme-full;
  # {
  #   extraPackages = tpkgs: { inherit (tpkgs) scheme-full cyrillic texindent; };
  # };

  home.packages = with pkgs; [
    i3lock
    pkg-config
    
    #  [dhall]
    dhall
    dhall-lsp-server

    haskell-language-server

    #  [nix]
    rnix-lsp

    #  [rust]
    rust-analyzer

    #  [markdown]
    pandoc

    #  [bash]
    nodePackages.bash-language-server
    glibc

    #  [java]
    eclipse-jdt-ls

    #  [kotlin]
    #  do I need this bullshit actually?

    #  [latex]
    # tex
    # texlive.combined.scheme-full
    texlab
    zathura

    #  [go]
    gopls

    #  [rust]
    cargo
    rustc

    #  [cpp]
    clang

    #  [java]
    #  jdk17
    #  jdk11
    #  lzy
    fuse

    # [racket]
    racket

    # [yaml]
    yaml-language-server

    # [html]
    #html-languageserver

    imagemagick
    inkscape


    # python-language-server
    (python39.withPackages (ps: with ps;[
      # default one to install local modules I guess?
      pip
      python-lsp-server

      # python lsp
      # jedi
      # pyls-mypy

      # python formatter
      # black
    ]))
  ];
}
